//
//	Mini WattHourMeter 0.4
//		adc.h
//		2009.10.29 1st rel
//			(c)2009 Toyohiko Togashi  tog001@nifty.com
//
#include	<htc.h>
#include	"adc.h"

void adc_start() {
	//	Port pin
	ANS0   = 1;		/* ANALOG */
	TRISA0 = 1;		/* input */
//	ANS1   = 1;		/* ANALOG */
//	TRISA1 = 1;		/* input */
//	ANS2   = 1;		/* ANALOG */
//	TRISA2 = 1;		/* input */
//	ANS3   = 1;		/* ANALOG */
//	TRISA3 = 1;		/* input */
//	ANS4   = 1;		/* ANALOG */
//	TRISA4 = 1;		/* input */
//	ANS5   = 1;		/* ANALOG */
//	TRISB6 = 1;		/* input */
//	ANS6   = 1;		/* ANALOG */
//	TRISB7 = 1;		/* input */

//	A/D module init
//	ANS3   = 1;		/* Ref+ ANALOG */
//	TRISA3 = 1;		/* Ref+ input */
	ADCON0 = 0b11000001;
//             xx...... ADCS: Tosc 00=2,4 01=8,16 10=32,64 11=RC
//             ..xxx... CHS: input channel
//             .....x.. GO/DONE: 1=go 0=done
//             .......x ADON: 1=on 0=shutdown
	ADCON1 = 0b10000000;
//             x....... ADFM: 1=Right 0=Left jusstified
//             .x...... ADCS: Tosc 0=2,8,32 1=4,16,64
//             ..xx.... VCFG: Vref 00=+Vdd-Vss 01=+Vdd-RA2 10=+RA3-Vss 11=+RA3-RA2
	return;
}

void
adc_stop() {
	ADCON0 = 0b00000000;
//             .......x ADON: 1=on 0=shutdown
	return;
}

/* Return an 16 bit result */
int adc_read(unsigned char channel) {
	ADCON0 = (ADCON0 & 0b11000111) | ((channel & 0b00000111) << 3);
	ADGO   = 1;
	while(ADGO)continue;
	return((ADRESH << 8) | ADRESL);	// return result
}